#ifndef SP_LDLT_DIAGONAL
#define SP_LDLT_DIAGONAL
#include "sp_names.h"
#include SP_SMATRIX_H

class sp_LDLT_diagonal
{ protected:
  sp_sMatrix A, F;
  ls_array1<ls_UINT> ind;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;
  int rc;
  sp_LDLT_diagonal(char* ="sp_LDLT_diagonal");
  sp_LDLT_diagonal(sp_sMatrix &, ls_REAL =0., char* ="sp_LDLT_diagonal");
  sp_LDLT_diagonal(sp_LDLT_diagonal &);
  unsigned char good()const{ return !rc;}
  sp_LDLT_diagonal& swap(sp_LDLT_diagonal &);
  const sp_LDLT_diagonal& operator=(const sp_LDLT_diagonal &);
  const sp_LDLT_diagonal& solve(ls_Vector &, const ls_Vector &) const;
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_LDLT_diagonal& write_row(ostream &) const;
  sp_LDLT_diagonal& read_row(istream &);
  const sp_LDLT_diagonal& write_column(ostream &) const;
  sp_LDLT_diagonal& read_column(istream &);
  const sp_LDLT_diagonal& operator>> (char *)const;
  sp_LDLT_diagonal& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LDLTDIAGONAL_C
#endif
#endif
