#ifndef SP_LU
#define SP_LU
#include "sp_names.h"
#include SP_MATRIX_H

class sp_LU
{ protected:
  sp_Matrix A, F;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name;
  ls_REAL eps;
  int rc;
  sp_LU(char* ="sp_LU");
  sp_LU(sp_Matrix &, ls_REAL =0., char* ="sp_LU");
  sp_LU(sp_LU &);
  unsigned char good()const{ return !rc;}
  sp_LU& swap(sp_LU &);
  const sp_LU& operator=(const sp_LU &);
  const sp_LU& solve(ls_Vector &, const ls_Vector &) const;
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_LU& write_row(ostream &) const;
  sp_LU& read_row(istream &);
  const sp_LU& write_column(ostream &) const;
  sp_LU& read_column(istream &);
  const sp_LU& operator>> (char *) const;
  sp_LU& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LU_C
#endif
#endif
