#ifndef SP_LU_DIAGONAL
#define SP_LU_DIAGONAL
#include "sp_names.h"
#include SP_MATRIX_H

class sp_LU_diagonal
{ protected:
  sp_Matrix A, F;
  ls_array1<ls_UINT> ind;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name, *ind_name;
  ls_REAL eps;
  int rc;
  sp_LU_diagonal(char* ="sp_LU_diagonal");
  sp_LU_diagonal(sp_Matrix &, ls_REAL =0., char* ="sp_LU_diagonal");
  sp_LU_diagonal(sp_LU_diagonal &);
  unsigned char good()const{ return !rc;}
  sp_LU_diagonal& swap(sp_LU_diagonal &);
  const sp_LU_diagonal& operator=(const sp_LU_diagonal &);
  const sp_LU_diagonal& solve(ls_Vector &, const ls_Vector &) const;
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_LU_diagonal& write_row(ostream &) const;
  sp_LU_diagonal& read_row(istream &);
  const sp_LU_diagonal& write_column(ostream &) const;
  sp_LU_diagonal& read_column(istream &);
  const sp_LU_diagonal& operator>> (char *) const;
  sp_LU_diagonal& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LUDIAGONAL_C
#endif
#endif
