#ifndef SP_MATRIX
#define SP_MATRIX
#include "sp_names.h"
#include LS_MATRIX_H
#include SP_VECTOR_H
#include SP_LIST2_H

class sp_Matrix: public sp_list2<ls_REAL>
{ public:
  sp_Matrix(ls_UINT =0, ls_UINT =0, char* ="sp_Matrix");
  sp_Matrix(ls_REAL*, ls_UINT, ls_UINT, char* ="sp_Matrix");
  sp_Matrix(sp_Matrix &);
  ls_Vector row(ls_UINT i)const
  { ls_Vector u(a->j); get_row(u,i,0); return u;}
  ls_Vector column(ls_UINT j)const
  { ls_Vector u(a->i); get_column(u,0,j); return u;}
  ls_Vector upper_diagonal(ls_UINT j) const
  { ls_UINT n=(a->i<a->j)?a->i:a->j; ls_Vector u(n);
    get_diagonal(u,0,j); return u;}
  ls_Vector lower_diagonal(ls_UINT i)const
  { ls_UINT n=(a->i<a->j)?a->i:a->j; ls_Vector u(n);
    get_diagonal(u,i,0); return u;}
  const sp_Matrix& operator=(const sp_Matrix &);
  sp_Matrix operator+(const sp_Matrix &)const;   //A+B
  sp_Matrix operator-(const sp_Matrix &)const;   //A-B
  sp_Matrix& operator+=(const sp_Matrix &);      //A=A+B
  sp_Matrix& operator-=(const sp_Matrix &);      //A=A-B
  sp_Matrix operator*(const sp_Matrix &)const;   //A*B
  sp_Vector operator* (const sp_Vector &)const;  //A*x
  ls_Vector operator* (const ls_Vector &)const;  //A*x
  ls_UINT solve(ls_Vector&, ls_Vector&) const;      //cg-Verfahren
};
sp_Vector operator* (const sp_Vector &, const sp_Matrix &);
ls_Vector operator* (const ls_Vector &, const sp_Matrix &);
sp_Matrix operator*(ls_REAL, const sp_Matrix &);  // s*A
#ifndef SP_LIB
#include SP_MATRIX_C
#endif
#endif
