//: $CC -DSP_LIB -DLS_LIB -c $file $OPTIONS
#ifndef SP_LIST2C
#define SP_LIST2C
#include "sp_names.h"
#include SP_LIST2_H

template<class T>
sp_list2<T>::sp_list2(ls_UINT m, ls_UINT n, char *nam):sp_list(2)
{ strcpy(name=ONAME,nam);
  if(!(m*n)) m=0, n=0;
  a=get2_el(); a->i=m, a->j=n, a->x=0, a->r_next=a->c_next=a;
  if(!m) return;
  ls_UINT mn=(m<n)? n:m;
  a->r_next=a->c_next=get2_el(mn); a->i=m, a->j=n;
  list2<T> *aa=a->r_next, *ae=aa+mn;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa->x=0, aa++;
}

template<class T>
sp_list2<T>::sp_list2(T *B, ls_UINT m, ls_UINT n, char *nam):sp_list(2)
{ static char *q1="sp_list2::sp_list2";
  strcpy(name=ONAME,nam);
  a=get2_el(); a->i=m, a->j=n ,a->x=0, a->r_next=a->c_next=a;
  if(!(m*n>0)) throw ls_error(name, q1, size_error_);
  ls_UINT i, j, mn=(m<n)? n:m;
  a->r_next=a->c_next=get2_el(mn); a->i=m, a->j=n;
  list2<T> *anf=a->r_next, *aa=anf, *ae=anf+mn, *ap, *ac, *ar;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa->x=0, aa++;
  T *b=B;
  for(i=0; i<m; b+=n, i++)
    for(j=0, ar=anf+i; j<n; j++)
    if(b[j])
    { ar=ar->r_next=get2_el(); ar->i=i, ar->j=j, ar->x=b[j], ar->r_next=a;
      ap=anf+j, ap->j+=1; while((ac=ap->c_next)->i<i) ap=ac;
      ap->c_next=ar, ar->c_next=ac, (anf+i)->i+=1;
    }
}

template<class T>
sp_list2<T>::sp_list2(sp_list2<T> &B):sp_list(2)
{ strcpy(name=ONAME,B.name);
  list2<T> *aa=B.asList();
  a=get2_el(); a->i=0, a->j=0, a->x=0, a->r_next=a->c_next=a;
  B.set_data(a); a=aa;
}

template<class T>
sp_list2<T>::~sp_list2()
{ if(a->r_next!=a)
  { ls_UINT mn=(a->i<a->j)? a->j:a->i;
    list2<T> *aa, *ap, *ba=a->r_next, *be=ba+mn;
    while((ap=ba)<be)
    { while((aa=ap->r_next)!=a){ ap->r_next=aa->r_next; ret2_el(aa);}
      ba++;
    }
    ret2_el(a->r_next,mn);
  }
  ret2_el(a);
  anz2--;
}

template<class T>
sp_list2<T>& sp_list2<T>::swap(sp_list2<T> &v)
{ char na[ls_len]; strcpy(na,name); strcpy(name,v.name); strcpy(v.name,na);
  list2<T> *aa=v.asList(); v.set_data(a); a=aa;
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::operator=(const sp_list2<T> &v)
{ static char *q1="sp_list2::=";
  ls_UINT m=v.number_of_rows(), n=v.number_of_columns(), i;
  if(!m) throw ls_error(v.name,q1,object_is_empty_);
  if(a->i&&(a->i!=m)&&(a->j!=n)) throw ls_error(name,q1,size_error_);
  remove(); a->i=m, a->j=n; ls_UINT mn=(m<n)? n:m;
  list2<T> *anf, *aa, *ap, *va=v.asList(), *vv, *ve=va, *ar;
  anf=aa=a->r_next=a->c_next=get2_el(mn); ap=aa+mn; vv=va=va->r_next;
  while(aa<ap)
    aa->r_next=aa->c_next=a, aa->i=vv->i, aa->j=vv->j, aa->x=0, aa++, vv++;
  for(i=0; i<m; i++)
  { vv=va+i, ar=anf+i;
    while((vv=vv->r_next)!=ve)
    { ar=ar->r_next=get2_el(); ar->r_next=a,
      ar->i=i, ar->j=vv->j, ar->x=vv->x,
      ap=anf+vv->j; while((aa=ap->c_next)->i<i) ap=aa;
      ap->c_next=ar, ar->c_next=aa;
    }
  }
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put(T s, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  list2<T> *ar, *ap, *ac, *anf=a->r_next;
  ap=anf+i; while((ar=ap->r_next)->j<j) ap=ar;
  if(ar->j==j)
  { if(s){ ar->x=s; return *this;}
    ap->r_next=ar->r_next, (anf+i)->i-=1;
    ap=anf+j, ap->j-=1; while((ac=ap->c_next)->i<i) ap=ac;
    ap->c_next=ac->c_next; ret2_el(ar);
    return *this;
  }
  if(!s) return *this;
  ap=ap->r_next=get2_el(); ap->i=i, ap->j=j, ap->x=s,
  ap->r_next=ar, ar=ap;
  ap=anf+j, ap->j+=1; while((ac=ap->c_next)->i<i) ap=ac;
  ar->c_next=ac, ap->c_next=ar, (anf+i)->i+=1;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_row(const sp_list1<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  while(k<nn) put(v.get(k++),i,j++);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_row(const ls_array1<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) put(*vv,i,j++), vv++;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_row(T s, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  while(j<a->j) put(s,i,j++);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_column(const sp_list1<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_column";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  while(k<nn) put(v.get(k++),i++,j);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_column(const ls_array1<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_column";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) put(*vv,i++,j);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_column(T s, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_column";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  while(i<a->i) put(s,i++,j);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_diagonal(const sp_list1<T> &v,ls_UINT i,ls_UINT j)
{ static char *q1="sp_list2::put_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  while(k<nn) put(v.get(k++),i++,j++);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_diagonal(T s,ls_UINT i,ls_UINT j)
{ static char *q1="sp_list2::put_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  while((i<a->i)&&(j<a->j)) put(s,i++,j++);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_array(const sp_list2<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_array";
  ls_UINT m=v.number_of_rows(), n=v.number_of_columns(),k,l,mm,nn;
  if(!m) throw ls_error(v.name,q1,object_is_empty_);
  mm=(a->i-i>m)? m:a->i-i; nn=(a->j-j>n)? n:a->j;
  for(k=0; k<mm; k++, i++)
    for(l=0; l<nn; l++) put(v.get(k,l),i,j+l);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_array(const ls_array2<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_array";
  ls_UINT m=v.number_of_rows(), n=v.number_of_columns(),k,l,mm,nn;
  if(!m) throw ls_error(v.name,q1,object_is_empty_);
  mm=(a->i-i>m)? m:a->i-i; nn=(a->j-j>n)? n:a->j;
  T *vv=v.asArray();
  for(k=0; k<mm; k++, i++, vv+=n)
    for(l=0; l<nn; l++) put(vv[l],i,j+l);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::put_array(T s, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put_array";
  ls_UINT m=a->i, n=a->j, k;
  if(!m) throw ls_error(name,q1,object_is_empty_);
  while(i<m){ for(k=j; k<n; put(s,i,k++)); i++;}
  return *this;
}

template<class T>
T sp_list2<T>::get(ls_UINT i, ls_UINT j) const
{ static char *q1="sp_list2::get";
  list2<T> *aa, *anf=a->r_next;
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  aa=anf+i; while((aa=aa->r_next)->j<j);
  if(aa->j==j) return aa->x; return 0;
}

template<class T>
const sp_list2<T>& sp_list2<T>::\
get_row(sp_list1<T> &v, ls_UINT i, ls_UINT j) const
{ static char *q1="sp_list2::get_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  while(k<nn) v.put(get(i,j++),k++);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::\
get_row(ls_array1<T> &v, ls_UINT i, ls_UINT j) const
{ static char *q1="sp_list2::get_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) *vv=get(i,j++), vv++;
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::\
get_column(sp_list1<T> &v, ls_UINT i,ls_UINT j) const
{ static char *q1="sp_list2::get_column";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  while(k<nn) v.put(get(i++,j),k++);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::\
get_column(ls_array1<T> &v, ls_UINT i,ls_UINT j) const
{ static char *q1="sp_list2::get_column";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) *vv=get(i++,j), vv++;
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::\
get_diagonal(sp_list1<T> &v, ls_UINT i,ls_UINT j) const
{ static char *q1="sp_list2::get_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  while(k<nn) v.put(get(i++,j++),k++);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::\
get_diagonal(ls_array1<T> &v, ls_UINT i,ls_UINT j) const
{ static char *q1="sp_list2::get_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) *vv=get(i++,j++), vv++;
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::get_array(sp_list2<T> &v,ls_UINT i,ls_UINT j) const
{ static char *q1="sp_list2::get_array";
  ls_UINT m=v.number_of_rows(), n=v.number_of_columns(),k,l,mm,nn;
  if(!m) throw ls_error(v.name,q1,object_is_empty_);
  mm=(a->i-i>m)? m:a->i-i; nn=(a->j-j>n)? n:a->j;
  for(k=0; k<mm; k++, i++)
    for(l=0; l<nn; l++) v.put(get(i,j+l),k,l);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::get_array(ls_array2<T> &v,ls_UINT i,ls_UINT j) const
{ static char *q1="sp_list2::get_array";
  ls_UINT mv=v.number_of_rows(), nv=v.number_of_columns(),l,mm,nn;
  if(!mv) throw ls_error(v.name,q1,object_is_empty_);
  mm=(a->i-i>mv)? mv:a->i-i; nn=(a->j-j>nv)? nv:a->j;
  T *vv=v.asArray(), *ve=vv+mm*nv;
  while(vv<ve){ for(l=0; l<nn; l++) vv[l]=get(i,j+l); i++, vv+=nv;}
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::append_row(ls_UINT l)
{ static char *q1="sp_list2::append_row";
  if(!a->i||!a->j) throw ls_error(name,q1,object_is_empty_);
  list2<T> *c, *aa, *ae;
  ls_UINT m=a->i, n=a->j, mn=(m+l<n)? n:m+l, ll=(m<n)? n:m;
  if(mn>ll)
  { c=get2_el(mn);
    memcpy(c,a->r_next,sizeof(list2<T>)*ll);
    memset(c+ll,0,sizeof(list2<T>)*(mn-ll));
    aa=c+ll; ae=aa+l;
    while(aa<ae) aa->r_next=aa->c_next=c, aa->i=aa->j=0, aa->x=0, aa++;
    ret2_el(a->r_next,0);a->r_next=a->c_next=c;
  }
  a->i+=l;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::append_column(ls_UINT l)
{ static char *q1="sp_list2::append_column";
  if(!a->i||!a->j) throw ls_error(name,q1,object_is_empty_);
  list2<T> *c, *aa, *ae;
  ls_UINT m=a->i, n=a->j, mn=(m<n+l)? n+l:m, ll=(m<n)? n:m;
  if(mn>ll)
  { c=get2_el(mn);
    memcpy(c,a->r_next,sizeof(list2<T>)*ll);
    memset(c+ll,0,sizeof(list2<T>)*(mn-ll));
    aa=c+ll; ae=aa+l;
    while(aa<ae) aa->r_next=aa->c_next=c, aa->i=aa->j=0, aa->x=0, aa++;
    ret2_el(a,0); a->r_next=a->c_next=c;
  }
  a->i+=l;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::append_array(ls_UINT mm, ls_UINT nn)
{ append_row(mm); append_column(nn); return *this;}

template<class T>
sp_list2<T>& sp_list2<T>::remove_row(ls_UINT i)
{ static char *q1="sp_list2::remove_row";
  if(!(i<a->i)) throw ls_error(name,q1,index_error_);
  list2<T> *anf=a->r_next, *aa=anf+i, *an;
  while(aa->r_next!=a) put(0,i,aa->j);
  ls_UINT mn=(a->i<a->j)? a->j:a->i;
  if(mn-i-1) memcpy(anf+i, anf+i+1, sizeof(list2<T>)*(mn-i-1));
  memset(anf+mn-1,0, sizeof(list2<T>));
  for(an=anf+a->j; anf<an; anf++)
  { aa=anf; while((aa=aa->c_next)->i<i);
    while(aa!=a) aa->i-=1, aa=aa->c_next;
  }
  a->i-=1;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::remove_column(ls_UINT j)
{ static char *q1="sp_list2::remove_column";
  if(!(j<a->j)) throw ls_error(name,q1,index_error_);
  list2<T> *anf=a->c_next, *aa=anf+j, *an;
  while(aa->c_next!=a) put(0,aa->i,j);
  ls_UINT mn=(a->i<a->j)? a->j:a->i;
  if(mn-j-1) memcpy(anf+j, anf+j+1, sizeof(list2<T>)*(mn-j-1));
  memset(anf+mn-1,0, sizeof(list2<T>));
  for(an=anf+a->i; anf<an; anf++)
  { aa=anf; while((aa=aa->r_next)->j<j);
    while(aa!=a) aa->i-=1, aa=aa->r_next;
  }
  a->j-=1;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::remove()
{ static char *q1="sp_list2::remove";
  ls_UINT mn=(a->i<a->j)? a->j:a->i;
  if(!mn) return *this;
  list2<T> *anf=a->r_next, *aa, *ap, *ba=anf, *be=ba+mn;
  while((ap=ba)<be)
  { ba->i=ba->j=0;
    while((aa=ap->r_next)!=a){ ap->r_next=aa->r_next; ret2_el(aa);}
    ba++;
  }
  ret2_el(anf,0); a->r_next=a->c_next=a, a->i=a->j=0;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::swap_row(ls_UINT i, ls_UINT k)
{ static char *q1="sp_list2::swap_row";
  if(!(i<a->i)||!(k<a->i)) throw ls_error(name,q1,index_error_);
  if(i==k) return *this;
  sp_list1<T> ai(a->i), ak(a->i); get_row(ai,i); get_row(ak,k);
  put_row(0,i); put_row(0, k); put_row(ai,k); put_row(ak,i);
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::swap_column(ls_UINT i, ls_UINT k)
{ static char *q1="sp_list2::swap_column";
  if(!(i<a->i)||!(k<a->i)) throw ls_error(name,q1,index_error_);
  if(i==k) return *this;
  sp_list1<T> ai(a->i), ak(a->i); get_column(ai,0,i); get_column(ak,0,k);
  put_column(0,0,i); put_column(0,0,k); put_column(ai,0,k); put_column(ak,0,i);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::write_row(ostream &f) const
{ static char *q1="sp_list2::write_row";
  list2<T> *anf=a->r_next, *aa;
  if(a==anf) throw ls_error(q1,name,object_is_empty_);
  ls_UINT m=a->i;
  f<<name<<endl;
  f<<"{ "<<number_of_rows_<<" "<<m<<" "<<number_of_columns_<<" "<<a->j<<endl;
  for (ls_UINT i=0; i<m; i++)
  { aa=anf+i, f<<row_<<" "<<i<<" "<<number_of_elements_<<" "<<aa->i<<endl;
    while((aa=aa->r_next)!=a) f<<aa->j<<" "<<aa->x<<" ";
    f<<endl;
  }
  f<<"}"<<endl;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::read_row(istream &f)
{ static char *q1="sp_list2::read_row";
  if(a->r_next!=a) throw ls_error(name, q1, object_not_empty_);
  char w[ls_len];
  list2<T> *anf, *aa, *ae, *ap, *ac;
  ls_UINT i, j, k, mn, m, n; T s;
  if(*name)while(f>>w&&strcmp(w,name));else f>>name;
  if(!f.good()) throw ls_error(name, q1, object_not_found_);
  f>>w;
  if(strcmp(w, "{")) throw ls_error(name,q1,object_contents_error_);
  if(!(f>>w)||strcmp(w,number_of_rows_)||!(f>>m))
    throw ls_error(name, q1, object_contents_error_);
  if(!(f>>w)||strcmp(w,number_of_columns_)||!(f>>n))
    throw ls_error(name, q1, object_contents_error_);
  mn=(m<n)? n:m;
  a->r_next=a->c_next=anf=get2_el(mn); a->i=m, a->j=n;
  aa=anf, ae=aa+mn;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa++;
  for (i=0; i<m; i++)
  { aa=anf+i;
    if(!(f>>w)||strcmp(w,row_)||!(f>>k)||(k!=i)||\
       !(f>>w)||strcmp(w, number_of_elements_)||!(f>>k))
       throw ls_error(name, q1, object_contents_error_);
    aa->i=k;
    while(k--)
    { f>>j, f>>s;
      aa=aa->r_next=get2_el(); aa->x=s, aa->i=i, aa->j=j, aa->r_next=a;
      ap=anf+j, ap->j+=1; while((ac=ap->c_next)->i<i) ap=ac;
      aa->c_next=ac, ap->c_next=aa;
    }
  }
  if(!(f>>w)||(*w!='}')) throw ls_error(name, q1, object_end_error_);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::write_column(ostream &f) const
{ static char *q1="sp_list2::write_column";
  list2<T> *aa, *anf=a->r_next;
  if(a==anf) throw ls_error(q1,name,object_is_empty_);
  ls_UINT n=a->j;
  f<<name<<endl;
  f<<"{ "<<number_of_columns_<<" "<<n<<" "<<number_of_rows_<<" "<<a->i<<endl;
  for (ls_UINT j=0; j<n; j++)
  { aa=anf+j, f<<column_<<" "<<j<<" "<<number_of_elements_<<" "<<aa->j<<endl;
    while((aa=aa->c_next)!=a) f<<aa->i<<" "<<aa->x<<" ";
    f<<endl;
  }
  f<<"}"<<endl;
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::read_column(istream &f)
{ static char *q1="sp_list2::read_column";
  if(a->r_next!=a) throw ls_error(name, q1, object_not_empty_);
  char w[ls_len];
  list2<T> *anf=a->r_next, *aa, *ae, *ar, *ap;
  ls_UINT i, j, k, mn, m, n; T s;
  if(*name)while(f>>w&&strcmp(w,name));else f>>name;
  if(!f.good()) throw ls_error(name, q1, object_not_found_);
  f>>w;
  if(strcmp(w, "{")) throw ls_error(name,q1,object_contents_error_);
  if(!(f>>w)||strcmp(w,number_of_columns_)||!(f>>n))
    throw ls_error(name, q1, object_contents_error_);
  if(!(f>>w)||strcmp(w,number_of_rows_)||!(f>>m))
    throw ls_error(name, q1, object_contents_error_);
  mn=(m<n)? n:m,
  a->r_next=a->c_next=anf=get2_el(mn); a->i=m, a->j=n;
  aa=anf, ae=aa+mn;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa++;
  for (j=0; j<n; j++)
  { aa=anf+j;
    if(!(f>>w)||strcmp(w,column_)||!(f>>k)||(k!=j)||\
       !(f>>w)||strcmp(w, number_of_elements_)||!(f>>k))
       throw ls_error(name, q1, object_contents_error_);
    aa->j=k;
    while(k--)
    { f>>i, f>>s;
      aa=aa->c_next=get2_el(); aa->x=s, aa->i=i, aa->j=j, aa->c_next=a;
      ap=anf+i, ap->i+=1; while((ar=ap->r_next)->j<j) ap=ar;
      aa->r_next=ar, ap->r_next=aa;
    }
  }
  if(!(f>>w)||(*w!='}')) throw ls_error(name, q1, object_end_error_);
  return *this;
}

template<class T>
const sp_list2<T>& sp_list2<T>::operator>> (char *nam) const
{ if(!*nam)
  { cout.setf(ios::fixed, ios::floatfield);
    cout.precision(int(sizeof(ls_REAL)*1.5));
    write_row(cout);
  }
  else
  { ofstream f(nam);
    f.setf(ios::scientific, ios::floatfield);
    f.precision(int(sizeof(ls_REAL)*1.5));
    write_row(f);
  }
  return *this;
}

template<class T>
sp_list2<T>& sp_list2<T>::operator<< (char *nam)
{ if(!*nam) read_row(cin); else{ ifstream f(nam); read_row(f);}
  return *this;
}

template<class T>
ls_REAL sp_list2<T>::filling_density()
{ list2<T> *anf=a->r_next;
  if(anf==a) return 0.;
  ls_UINT i, l=0, m=a->i, ne=m*a->j;
  for (i=0; i<m; i++, l+=(anf+i)->i);
  return (l+0.)/(ne+0.);
}
#endif
