//: $CC -DSPLIB -DLSLIB -c $file $OPTIONS
#ifndef SP_LISTUC
#define SP_LISTUC
#include "sp_names.h"
#include SP_LISTU_H

template<class T>
sp_listU<T>::sp_listU(ls_UINT n, char *nam):sp_list(2)
{ strcpy(name=ONAME,nam);
  a=get2_el(); a->i=a->j=n, a->x=0, a->r_next=a->c_next=a;
  if(!n) return;
  a->r_next=a->c_next=get2_el(n);
  list2<T> *aa=a->r_next, *ae=aa+n;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa->x=0, aa++;
}

template<class T>
sp_listU<T>::sp_listU(sp_listU<T> &B):sp_list(2)
{ strcpy(name=ONAME,B.name);
  list2<T> *aa=B.asList();
  a=get2_el(); a->r_next=a->c_next=a, a->i=a->j=0, a->x=0;
  B.set_data(a); a=aa;
}

template<class T>
sp_listU<T>::~sp_listU()
{ if(a->r_next!=a)
  { ls_UINT n=a->j;
    list2<T> *aa, *ap, *ba=a->r_next, *be=ba+n;
    while((ap=ba)<be)
    { while((aa=ap->r_next)!=a){ ap->r_next=aa->r_next; ret2_el(aa);}
      ba++;
    }
    ret2_el(a->r_next,n);
  }
  ret2_el(a); anz2--;
}

template<class T>
sp_listU<T>& sp_listU<T>::swap(sp_listU<T> &v)
{ char na[ls_len]; strcpy(na,name); strcpy(name,v.name); strcpy(v.name,na);
  list2<T> *aa=v.asList(); v.set_data(a); a=aa;
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::operator=(const sp_listU<T> &v)
{ static char *q1="sp_listU::=";
  list2<T> *aa, *ap, *anf, *ar, *va=v.asList(), *ve=va, *vv;
  ls_UINT vdim=v.dimension();
  if(a->i&&(vdim!=a->i)) throw ls_error(name, q1, size_error_);
  remove();a->i=a->j=vdim;
  anf=aa=a->r_next=a->c_next=get2_el(vdim); ap=aa+vdim;
  while(aa<ap) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa->x=0, aa++;
  va=va->r_next;
  for (ls_UINT i=0; i<vdim; i++)
  { vv=va+i, ar=anf+i, ar->i=vv->i, ar->j=vv->j;
    while((vv=vv->r_next)!=ve)
    { ar=ar->r_next=get2_el(); ar->r_next=a,
      ar->i=vv->i, ar->j=vv->j, ar->x=vv->x;
      ap=anf+vv->j; while((aa=ap->c_next)->i<i) ap=aa;
      ap->c_next=ar, ar->c_next=aa;
    }
  }
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put(T s, ls_UINT i, ls_UINT j)
{ static char *q1="sp_list2::put";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  list2<T> *aa, *ar, *ac, *anf=a->r_next;
  ls_UINT l;
  if(i>j) l=i, i=j, j=l;
  ar=anf+i; while((aa=ar->r_next)->j<j) ar=aa;
  if(aa->j==j)
  { if(s) aa->x=s;
    else
    { ar->r_next=aa->r_next, ar=aa;
      ac=anf+j, ac->j-=1; while((aa=ac->c_next)!=ar) ac=aa;
      ac->c_next=aa->c_next; ret2_el(ar); (anf+i)->i-=1;
    }
    return *this;
  }
  if(!s) return *this;
  ar=ar->r_next=get2_el(); ar->i=i, ar->j=j, ar->x=s, ar->r_next=aa;
  ac=anf+j, ac->j+=1; while((aa=ac->c_next)->i<i) ac=aa;
  ar->c_next=aa, ac->c_next=ar, (anf+i)->i+=1;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_row(const sp_list1<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_listU::put_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  while(k<nn) put(v.get(k++),i,j++);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_row(const ls_array1<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_listU::put_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) put(*vv,i,j++), vv++;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_row(T s, ls_UINT i, ls_UINT j)
{ static char *q1="sp_listU::put_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  while(j<a->j) put(s,i,j++);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_diagonal(const sp_list1<T> &v,ls_UINT i,ls_UINT j)
{ static char *q1="sp_listU::put_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  while(k<nn) put(v.get(k++),i++,j++);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_diagonal(const ls_array1<T> &v,ls_UINT i,ls_UINT j)
{ static char *q1="sp_listU::put_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) put(*vv,i++,j++), vv++;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_diagonal(T s,ls_UINT i,ls_UINT j)
{ static char *q1="sp_listU::put_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  while((i<a->i)&&(j<a->i)) put(s,i++,j++);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_array(const sp_listU<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_listU::put_array";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k, l, vdim=v.dimension(), nn=(a->i-i>a->i-j)? a->i-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  for(k=0; k<nn; k++, i++)
    for(l=k; l<nn; l++) put(v.get(k,l),i,j+l);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::put_array(const ls_arrayU<T> &v, ls_UINT i, ls_UINT j)
{ static char *q1="sp_listU::put_array";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k, l, vdim=v.dimension(), nn=(a->i-i>a->i-j)? a->i-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  for(k=0; k<nn; k++, i++)
    for(l=k; l<nn; l++) put(v[k][l],i,j+l);
  return *this;
}

template<class T>
T sp_listU<T>::get(ls_UINT i, ls_UINT j) const
{ static char *q1="sp_listU::get";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT l;
  list2<T> *aa, *anf=a->r_next;
  if(i>j) l=i, i=j, j=l;
  aa=anf+i; while((aa=aa->r_next)->j<j);
  if(aa->j==j) return aa->x; return 0;
}

template<class T>
const sp_listU<T>& sp_listU<T>::\
get_row(sp_list1<T> &v, ls_UINT i,ls_UINT j) const
{ static char *q1="sp_listU::get_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  while(k<nn) v.put(get(i,j++),k++);
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::\
get_row(ls_array1<T> &v, ls_UINT i,ls_UINT j) const
{ static char *q1="sp_listU::get_row";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->j-j<vdim)? a->j-j:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) *vv=get(i,j++), vv++;
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::\
get_diagonal(sp_list1<T> &v,ls_UINT i,ls_UINT j) const
{ static char *q1="sp_listU::get_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  while(k<nn) v.put(get(i++,j++),k++);
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::\
get_diagonal(ls_array1<T> &v,ls_UINT i,ls_UINT j) const
{ static char *q1="sp_listU::get_diagonal";
  if(!(i<a->i)||!(j<a->j)) throw ls_error(name,q1,index_error_);
  ls_UINT k=0, vdim=v.dimension(), nn=(a->i-i>a->j-j)? a->j-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  T *vv=v.asArray(), *ve=vv+nn;
  while(vv<ve) *vv=get(i++,j++), vv++;
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::get_array(sp_listU<T> &v, ls_UINT i, ls_UINT j) const
{ static char *q1="sp_listU::get_array";
  ls_UINT k, l, vdim=v.dimension(),nn=(a->i-i>a->i-j)? a->i-j:a->i-i;;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  for(k=0; k<nn; k++, i++)
    for(l=k; l<nn; l++) v.put(get(i,j+l),k,l);
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::get_array(ls_arrayU<T> &v, ls_UINT i, ls_UINT j) const
{ static char *q1="sp_listU::get";
  ls_UINT k, l, vdim=v.dimension(), nn=(a->i-i>a->i-j)? a->i-j:a->i-i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(nn>vdim) nn=vdim;
  for(k=0; k<nn; k++, i++)
    for(l=k; l<nn; l++) v.put(get(i,j+l),k,l);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::append_row(ls_UINT l)
{ static char *q1="sp_listU::append_row";
  if(!a->i||!a->j) throw ls_error(name,q1,object_is_empty_);
  list2<T> *c, *aa, *ae;
  ls_UINT n=a->j, ll=n+l;
  c=get2_el(ll);
  memcpy(c,a->r_next,sizeof(list2<T>)*n);
  memset(c+ll,0,sizeof(list2<T>)*(n-ll));
  aa=c+ll; ae=aa+l;
  while(aa<ae) aa->r_next=aa->c_next=c, aa->i=aa->j=0, aa->x=0, aa++;
  ret2_el(a->r_next,0); a->r_next=a->c_next=c;
  a->i+=l; a->j=a->i;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::remove_row(ls_UINT i)
{ static char *q1="sp_listU::remove_row";
  if(!(i<a->i)) throw ls_error(name,q1, index_error_);
  list2<T> *anf=a->r_next, *aa=anf+i, *an; ls_UINT n=a->i;
  while(aa->r_next!=a) put(0,i,aa->j);
  if(n-i-1) memcpy(anf+i, anf+i+1, sizeof(list2<T>)*(n-i-1));
  memset(anf+n-1,0, sizeof(list2<T>));
  for(an=anf+a->j; anf<an; anf++)
  { aa=anf; while((aa=aa->c_next)->i<i);
    while(aa!=a) aa->i-=1, aa=aa->c_next;
  }
  a->i-=1; a->j=a->i;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::remove()
{ list2<T> *aa, *ap, *anf=a->r_next;
  if(!a->i) return *this;
  for (ls_UINT i=0; i<a->i; i++)
  { ap=anf+i, ap->i=ap->j=0, ap->c_next=a;
    while((aa=ap->r_next)!=a){ ap->r_next=aa->r_next; ret2_el(aa);}
  }
  ret2_el(anf,0); a->i=a->j=0, a->r_next=a->c_next=a;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::swap_row(ls_UINT i, ls_UINT k)
{ static char *q1="sp_listU::swap_row";
  if(!(i<a->i)||!(k<a->i)) throw ls_error(name,q1,index_error_);
  if(i==k) return *this;
  sp_list1<T> ai(a->i), ak(a->i);
  get_row(ai,i); get_row(ak,k); put_row(0.,i), put_row(0.,k);
  put_row(ai,k); put_row(ak,i);
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::write_row(ostream &f) const
{ static char *q1="write_row";
  list2<T> *aa, *anf=a->r_next; ls_UINT n=a->i;
  if(a==anf) throw ls_error(q1,name,object_is_empty_);
  f<<name<<endl<<"{ "<<dimension_<<" "<<n<<endl;
  for (ls_UINT i=0; i<n; i++)
  { aa=anf+i, f<<row_<<" "<<i<<" "<<number_of_elements_<<" "<<aa->i<<endl;
    while((aa=aa->r_next)!=a) f<<aa->j<<" "<<aa->x <<" ";
    f<<endl;
  }
  f<<"}"<<endl;
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::write_column(ostream &f) const
{ static char *q1="write_column";
  list2<T> *aa, *anf=a->r_next; ls_UINT n=a->j;
  if(a==anf) throw ls_error(q1,name,object_is_empty_);
  f<<name<<endl<<"{ "<<dimension_<<" "<<n<<endl;
  for (ls_UINT j=0; j<n; j++)
  { aa=anf+j, f<<column_<<" "<<j<<" "<<number_of_elements_<<" "<<aa->j<<endl;
    while((aa=aa->c_next)!=a) f<<aa->i<<" "<<aa->x <<" ";
    f<<endl;
  }
  f<<"}"<<endl;
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::read_row(istream &f)
{ static char *q1="sp_listU::read_row";
  if(a->r_next!=a) throw ls_error(name, q1, object_not_empty_);
  char w[ls_len];
  list2<T> *anf, *aa, *ae, *ap, *ac;
  ls_UINT i, j, k, n; T s;
  if(*name)while(f>>w&&strcmp(w,name));else f>>name;
  if(!f.good()) throw ls_error(name, q1, object_not_found_);
  f>>w;
  if(strcmp(w, "{")) throw ls_error(name,q1,object_contents_error_);
  if(!(f>>w)||strcmp(w,dimension_)||!(f>>n))
    throw ls_error(name, q1, object_contents_error_);
  a->r_next=a->c_next=anf=get2_el(n); a->i=n, a->j=n; aa=anf, ae=aa+n;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa->x=0, aa++;
  for (i=0; i<n; i++)
  { aa=anf+i;
    if(!(f>>w)||strcmp(w,row_)||!(f>>k)||(k!=i)||\
       !(f>>w)||strcmp(w, number_of_elements_)||!(f>>k))
       throw ls_error(name, q1, object_contents_error_);
    aa->i=k;
    while(k--)
    { f>>j, f>>s;
      aa=aa->r_next=get2_el(); aa->x=s, aa->i=i, aa->j=j;
      ap=anf+j, ap->j+=1; while((ac=ap->c_next)->i<i) ap=ac;
      aa->c_next=ac, ap->c_next=aa;
    }
    aa->r_next=a;
  }
  if(!(f>>w)||(*w!='}')) throw ls_error(name, q1, object_end_error_);
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::read_column(istream &f)
{ static char *q1="sp_listU::read_column";
  if(a->r_next!=a) throw ls_error(name, q1, object_not_empty_);
  char w[ls_len];
  list2<T> *anf, *aa, *ae, *ar, *ap;
  ls_UINT i, j, k, n; T s;
  if(*name)while(f>>w&&strcmp(w,name));else f>>name;
  if(!f.good()) throw ls_error(name, q1, object_not_found_);
  f>>w;
  if(strcmp(w, "{")) throw ls_error(name,q1,object_contents_error_);
  if(!(f>>w)||strcmp(w,dimension_)||!(f>>n))
    throw ls_error(name, q1, object_contents_error_);
  a->r_next=a->c_next=anf=get2_el(n); a->i=n, a->j=n; aa=anf, ae=aa+n;
  while(aa<ae) aa->r_next=aa->c_next=a, aa->i=aa->j=0, aa->x=0, aa++;
  for (j=0; j<n; i++)
  { aa=anf+j;
    if(!(f>>w)||strcmp(w,column_)||!(f>>k)||(k!=j)||\
        !(f>>w)||strcmp(w, number_of_elements_)||!(f>>k))
       throw ls_error(name, q1, object_contents_error_);
    aa->j=k;
    while(k--)
    { f>>i, f>>s;
      aa=aa->c_next=get2_el(); aa->x=s, aa->i=i, aa->j=j, aa->c_next=a;
      ap=anf+i, ap->i+=1; while((ar=ap->r_next)->j<j) ap=ar;
      aa->r_next=ar, ap->r_next=aa;
    }
  }
  if(!(f>>w)||(*w!='}')) throw ls_error(name, q1, object_end_error_);
  return *this;
}

template<class T>
const sp_listU<T>& sp_listU<T>::operator>> (char *nam) const
{ if(!*nam)
  { cout.setf(ios::fixed, ios::floatfield);
    cout.precision(int(sizeof(ls_REAL)*1.5));
    write_row(cout);
  }
  else
  { ofstream f(nam);
    f.setf(ios::scientific, ios::floatfield);
    f.precision(int(sizeof(ls_REAL)*1.5));
    write_row(f);
  }
  return *this;
}

template<class T>
sp_listU<T>& sp_listU<T>::operator<< (char *nam)
{ if(!*nam) read_row(cin); else{ ifstream f(nam); read_row(f);}
  return *this;
}

template<class T>
ls_REAL sp_listU<T>::filling_density()
{ list2<T> *anf=a->r_next;
  if(anf==a) return 0;
  ls_UINT i, l=0, n=anf->i, ne=(n*(n+1))/2;
  for (i=0; i<n; l+=(anf+i)->i, i++);
  return ls_REAL((l+0.)/ne);
}
#endif
