#ifndef SP_sCG_PRECOND
#define SP_sCG_PRECOND
#include "sp_names.h"
#include SP_SMATRIX_H

class sp_sCG_precond
{ protected:
  sp_sMatrix A, F;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name;
  ls_REAL eps;
  int rc;
  sp_sCG_precond(char* ="sCG_precond");
  sp_sCG_precond (sp_sMatrix &, ls_REAL =0.,char* ="sCG_precond");
  sp_sCG_precond(sp_sCG_precond &);
  unsigned char good()const{ return !rc;}
  sp_sCG_precond& swap(sp_sCG_precond &);
  const sp_sCG_precond& operator=(const sp_sCG_precond &);
  ls_UINT solve(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_sCG_precond& write_row(ostream &) const;
  sp_sCG_precond& read_row(istream &);
  const sp_sCG_precond& write_column(ostream &) const;
  sp_sCG_precond& read_column(istream &);
  const sp_sCG_precond& operator>> (char *) const;
  sp_sCG_precond& operator<< (char *);
};
#ifndef SP_LIB
#include SP_SCGPRECOND_C
#endif
#endif
